In my class, i have to calculate prices of 18 different building which have different prices and income. They also have changes in price when the money of quantity of the building increases.
For example: The building starts at 40 dollars when the quantity is 0. The price increments by 4 for each quantity. So if you own 1, the price to buy the next same building will be 44 in state of 40. So this is the method that will calculate the price just fine.
public float getBuildingPrice(float quantity)
{
float buildingNum = quantity;
float startingPrice = 40;
float costIncrease = 4;
float finalPrice;
finalPrice = startingPrice + (costIncrease*buildingNum);
return finalPrice;
}
The method above returns the price and i divided the calculated price with the income that comes to the building like this. 10 is the income
float storageWorth = buildingPrice/10;
The thing i am unable to do is to find out the amount of different building the user can buy in the most efficient way ( meaning highest income but lowest spending ) So it should be the lowest Price / income that should be fulfilling the condition but also keeping in mind that it must be in the budget that the user keys in. There is always a change in the price and i do not know how to compare multiple values ( 18 values ) with the extra condition to keep in the budget.
For example
Farm
Income - 1
5 buildings
Increment of 4
Price 40 + (5 * 4) = 60
Price over income = 60
Pen
Income - 5
4 Buildings
Increment of 20
Price 200 + (4 * 20) = 280
Price over income 280/5 = 56
So meaning to say the next building the user should buy is a pen because it has lower price/income. There is also chances that the price over income of both building is the same like if the building reaches 5 for pen building, both price over income of pen and farm will be 60.
This is a formulation of your problem that ends up a mixed integer and non linear programming problem:
For all building type i let's define:
Pi : price of building type i
Ci : Price increment of building type i
Mi : income for building type i
B : Budget
Ni : Number of buildings of type i purchased.
Purchasing Ni building of type i equals:
Sum for j=1 to Ni Pi + (j - 1) × Ci = Ni (Pi + ( Ni - 1) / 2 × Ci)
Mixed integer non linear programming formulation:
Maximise Sum for i Ni × Mi
Subject to : sum for i Ni (Pi + (Ni - 1) / 2 ×Ci) <= B
Note that Pi, Ci, Mi and B are constants. Decision variables are Ni
An other solution is to purchase a building at a time selecting the one with the maximum income per invested money as per the following ratio:
Mi / (Ni (Pi + ( Ni - 1) / 2 × Ci))
At each step you calculate the building with the maximum ratio, purchase a building, deduct the price of the budget and repeat until the budget is exhausted. I do not have a proof that you will get an optimum my following this algorithm.
Third solution pseudocode (brute force):
(income, index_list) function maximize_income(i, b)
if i > last_building_type
return 0, []
endif
max_income = 0
max_income_index = 0
while b >= P(i) - (j-1) * C(i)
b = b - P(i) - (j-1) * C(i)
(income, index_list) = maximize_income(i+1, b)
income = income + j * M(i)
if income > maximum_income
maximum_income = income
maximum_income_index = j
endif
endwhile
add maximum_income_index to index_list
return maximum_income, index_list
end function
index_list is an array containing the number of each type of building
Your problem is a linear programming problem. Such problems don't have easy answers.
To solve such problems, people have invented many smart algorithms like the Simplex Algorithm.
These alogrigthms work on a represenation of the problem that basically is a set of mathematical linear equations. You have to think hard about your problem and formulate these equations.
A C library to solve a LP problem forumlated this way is the GLPK (GNU Linear Programming Kit). There are frontends for Python and for Java.
Your question is not a programming problem. It is a mathematical problem that can be solved in any language. Give enough time, it can even be solved on paper.
Related
I have a plugin that i made for Minecraft. It is used for massive ender dragon fights to divide the EXP fairly among everybody, based on the damage dealt.
It works but there's a hiccup that makes the equation miss experience.
Here's the code:
private void divideExpAmongstPlayersBasedOnDamageDealt(int exp, Map<Player, Double> damageMap) {
double totalDamageDealt = 0.0d;
for (Double value : damageMap.values()) {
totalDamageDealt += value;
}
while (exp > 0 && !damageMap.isEmpty()) {
Player maxHitterInList = Collections.max(damageMap.entrySet(),
Comparator.comparingDouble(Map.Entry::getValue)).getKey();
double damageShare = damageMap.get(maxHitterInList) / totalDamageDealt;
int expShare = (int) Math.round(exp * damageShare);
if (expShare == 0)
break;
if (maxHitterInList.isOnline()) {
sendPlayerMessage(maxHitterInList, damageShare, expShare);
maxHitterInList.giveExp(expShare);
}
exp -= expShare;
damageMap.remove(maxHitterInList);
}
}
It finds the max hitter, awards them their share of EXP and removes them from the list, until there is no more EXP left to give.
The problem is that it misses points, forcing me to add && !damageMap.isEmpty() to the while condition to avoid exceptions.. It prints the percentages accurately always (the sum adds up to 100).
Im thinking it has to do with the Math.round function, although i am in the dark as how to debug this. When i do the calculations by hand they work out.
Example (this literally happened): A mob grants 10 exp. Player1 did 57% of damage, Player2 did 43%. The percentage values get printed correctly, yet Player1 receives 6 EXP and Player2 receives 2?? Last time i checked 0.57 * 10 equals 5.7 = 6 and 0.43 * 10 equals 4.3 = 4.
What am i missing? Does it have to do with the round function or the way doubles work?
Thanks
This is not a rounding issue but you are using the wrong value in your calculation.
You wrote "Last time i checked 0.57 * 10 equals 5.7 = 6 and 0.43 * 10 equals 4.3 = 4" but the formula you use is
int expShare = (int) Math.round(exp * damageShare);
and you update exp for each iteration of the loop
exp -= expShare;
which means for your second player exp is for 4 and not 10 as you assumed in your example so the real calculation is 0.43 * 2 which rounded is 2
So you need to separate between the variable used in the condition for the while and the one used in the calculation.
I have a data set needs to calculate the accuracy of it using KNN classifier, I have tried to do that using the below code but it does not work.could someone state why?
Actually I need to calculate the Acc from weka inside java
private void Fitness(){
double Acc = 0.0;
double tp=0;
double tn=0;
double fp=0;
double fn=0;
Acc = (tp + tn)/ (tp + tn + fp + fn);
}
In machine learning , calculating the accuracy is ,
number of correct predictions / total number of predictions
And the error margin is given by ,
number of wrong predictions / total number of predictions
Suppose ,I have made 10 total predictions out of which 2 were correct whereas 8 were incorrect.
Then Acc = 2 / 10 , error = 8 / 10
I have two items in the cart item 1= $70 and item 2= $100 and i also have the total shipping i can charge, which is $15. While accepting this order Im trying to split the $15 shipping between item1 and item2 in a weighted manner based on the price. What is the best algorithm to split this and what is the logic/calculation look like ?
Any thoughts helpful, thanks !
I don't know Java, but since you included no Java code, I'll just give pseudocode to how to do this:
a = 70 / (70 + 100)
b = 100 / (70 + 100)
This normalizes the two values, and then you can just multiply a and b with $15 to get the proper ratio. In this case, a is 0.41 and b is 0.59
Then:
ratio_item_a = 15 * a
ratio_item_b = 15 * b
ratio_item_a is 6.18 and ratio_item_b is 8.82
Write a program that reads the total number of pieces of oranges, eggs, apples, watermelons, and bagels they purchased. Calculate the total bill and subtotals for each item using the following prices:
a.Oranges: 10 for 2.99/0.50 each
b.Eggs: 12 for 1.69/0.25 each
c.Apples: 3 for 1.00/0.75 each
d.Watermelons: 4.39 each
e.Bagels: 6 for 3.50/0.95 each
I'm a little bit confused for on what method should I use to program/solve this problem? I'm thinking to use a If statement but I think it's not a good idea. How should i start my coding? This is my first time encountering a price system with (I think discount?) fix amount of price on each item. It's bothering me to think that how can i do a "2.99 for 10 apples" while one apple is 0.50?" should I use discount? My mind is bleeding right now -_-
Here is an algorithm for solving the problem. Go step by step and implement the logic. I am sure you will get the final result.
Take the count for one fruit and display it.
From the count, calculate the sub-total price by taking the rate as per piece. Display the sub-total.
Store the sub-total you got in 2nd step in a separate variable and display it.
Follow the steps 1 to 3 for other fruits now, storing the sub-total of each fruit in a separate variable.
Calculate the final total by adding the values of all sub-total variables.
For applying the discounts, you can use a simple if...else logic along with some arithmetic operators.
6.1 Divide the count by 10 (for oranges) and store it in a variable called tmp.
6.2 If tmp is greater than 0,
subTotal = tmp * price_of_10
count = count - (tmp * 10)
subTotal = subTotal + (count * price_of_1)
6.3 If tmp is equal to zero
subTotal = count * price_of_1
I can help you get started. I don't want to give you all the code because I still want you to learn from it.
//Read number of Oranges here
//Some code
if(number = 10) price = 2.99
else price = number*0.50
total += price
Repeat for other products, don't forget to change the price value
EDIT: if you want to buy more than 10 and still get the discount, you will need to do something like this
int ten = 0;
Double rest =0;
if(number/10 >= 1){
ten = number/10;
rest = number%10;
price = ten*2.99 + rest*0.50;
}else{
price = number*0.50
}
total += price
Example 1:
Shop selling beer, available packages are 6 and 10 units per package. Customer inputs 26 and algorithm replies 26, because 26 = 10 + 10 + 6.
Example 2:
Selling spices, available packages are 0.6, 1.5 and 3. Target value = 5. Algorithm returns value 5.1, because it is the nearest greater number than target possible to achieve with packages (3, 1.5, 0.6).
I need a Java method that will suggest that number.
Simmilar algorithm is described in Bin packing problem, but it doesn't suit me.
I tried it and when it returned me the number smaller than target I was runnig it once again with increased target number. But it is not efficient when number of packages is huge.
I need almost the same algorithm, but with the equal or greater nearest number.
Similar question: Find if a number is a possible sum of two or more numbers in a given set - python.
First let's reduce this problem to integers rather than real numbers, otherwise we won't get a fast optimal algorithm out of this. For example, let's multiply all numbers by 100 and then just round it to the next integer. So say we have item sizes x1, ..., xn and target size Y. We want to minimize the value
k1 x1 + ... + kn xn - Y
under the conditions
(1) ki is a non-positive integer for all n ≥ i ≥ 1
(2) k1 x1 + ... + kn xn - Y ≥ 0
One simple algorithm for this would be to ask a series of questions like
Can we achieve k1 x1 + ... + kn xn = Y + 0?
Can we achieve k1 x1 + ... + kn xn = Y + 1?
Can we achieve k1 x1 + ... + kn xn = Y + z?
etc. with increasing z
until we get the answer "Yes". All of these problems are instances of the Knapsack problem with the weights set equal to the values of the items. The good news is that we can solve all those at once, if we can establish an upper bound for z. It's easy to show that there is a solution with z ≤ Y, unless all the xi are larger than Y, in which case the solution is just to pick the smallest xi.
So let's use the pseudopolynomial dynamic programming approach to solve Knapsack: Let f(i,j) be 1 iif we can reach total item size j with the first i items (x1, ..., xi). We have the recurrence
f(0,0) = 1
f(0,j) = 0 for all j > 0
f(i,j) = f(i - 1, j) or f(i - 1, j - x_i) or f(i - 1, j - 2 * x_i) ...
We can solve this DP array in O(n * Y) time and O(Y) space. The result will be the first j ≥ Y with f(n, j) = 1.
There are a few technical details that are left as an exercise to the reader:
How to implement this in Java
How to reconstruct the solution if needed. This can be done in O(n) time using the DP array (but then we need O(n * Y) space to remember the whole thing).
You want to solve the integer programming problem min(ct) s.t. ct >= T, c >= 0 where T is your target weight, and c is a non-negative integer vector specifying how much of each package to purchase, and t is the vector specifying the weight of each package. You can either solve this with dynamic programming as pointed out by another answer, or, if your weights and target weight are too large then you can use general integer programming solvers, which have been highly optimized over the years to give good speed performance in practice.